#include <bits/stdc++.h>
 
 using namespace std;
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    
    int n,q;
    cin>>n>>q;
    vector<long long int>dani(n);
    vector<long long int>kp(n);
    vector<long long int>ud(q);
    vector<pair<long long int,bool>>svidani;
    for(int i=0;i<n;i++){
        cin>>dani[i]>>kp[i];
        svidani.push_back(make_pair(dani[i]-1,true));
    }
    for(int i=0;i<q;i++){
        cin>>ud[i];
        svidani.push_back(make_pair(ud[i],false));
    
    }
    sort(svidani.begin(), svidani.end(), [](const std::pair<long long int, bool>& a, const std::pair<long long int, bool>& b) {
        return a.first < b.first; 
    });
    long long int dp;
    long long int ds;
    long long int pp=0;
    long long int kucip=0;
    int j=0;
    if(svidani[0].second==true){
            kucip+=kp[0];
            j++;}
    else{
        cout<<pp<<endl;
    }
    ds=svidani[0].first;
    for(int i=1;i<svidani.size();i++){
        
        dp=ds;
        ds=svidani[i].first;
        if((ds-dp)>=kucip){
            pp+=kucip;
            kucip=0;
            }
        else if((ds-dp)<kucip){
            pp+=(ds-dp);
            kucip-=(ds-dp);
        }  
        /*cout<<dp<<endl;
        cout<<ds<<endl;
        cout<<kucip<<endl;    
        cout<<pp<<endl;
        cout<<"---"<<endl;
        */if(svidani[i].second==true){
            kucip+=kp[j];
            //cout<<kp[j]<<endl;
            j++;
        }
       
        if(svidani[i].second==false){
            cout<<pp<<endl;
        }
    }
}